Autolib="Objects"
    
Proc Sweat()
     private Deck,Player_1,Player_2,i,x
     ;---------------------------CREATE 'OBJECT BASED PAL' Object Enviornment   
     OBP.Create()
  
     ;---------------------------CREATE TWO PLAYERS 
     Player_1 = Stack.Create()
     Player_2 = Stack.Create()

     ;---------------------------CREATE AND SHUFFLED DECK OF CARDS
     Deck = CardDeck.Create()
     
     ;---------------------------DEAL THE TWO HANDS
     for i from 1 to 8
         Stack.Push( Player_1, CardDeck.DealCard(Deck) )
         Stack.Push( Player_2, CardDeck.DealCard(Deck) )
     endfor       
     
     ;---------------------------REVEAL THE CARDS ONE BY ONE
     Clear
     PaintCanvas Fill " " Attribute 112 0,0,24,79
     @ 5,15 ?? "PLAYER 1" 
     @ 5,45 ?? "PLAYER 2" 
     for i from 1 to 8
         x=getchar()
         Card=Stack.Pop(Player_1)
         CardDeck.DisplayCard( Card, 6+i*1, 05+i*3) 

         x=getchar()
         Card=Stack.Pop(Player_2)
         CardDeck.DisplayCard( Card, 6+i*1, 35+i*3) 
         
     endfor       
     Beep
     x=getchar()
     
     ;---------------------------DESTROY PLAYERS AND DECK      
     Stack.Destroy(Player_1)
     Stack.Destroy(Player_2)
     Stack.Destroy(Deck)
     
     ;---------------------------DESTROY OBP Object Envoinmental
     OBP.Destroy()

EndProc       

;---A CLASS UTILITY

Proc CardDeck.DisplayCard(Card,R,C)
     private Suit,i,Colr,Rank,si,Height,Width
     
     Cursor Off
     Sysinfo to si
     Height=6
     Width=IIF(Si["ScreenHeight"]=25,10,6)
     
     Suit=Substr(Card,Len(Card),1)
     Rank=Substr(Card,1,Len(Card)-2)
     
     Colr=112
     If Suit=Chr(3) or Suit=Chr(4) then
        Colr=116
     Endif
     Style Attribute Colr

     PaintCanvas Fill " " Attribute Colr  r,c,r+Height,c+Width
     Frame Single From R,C to R+Height,C+Width
     PaintCanvas Border Attribute 112 R,C,R+Height,C+Width
     PaintCanvas Border Attribute 127 R,C+Width,R+Height,C+Width
     PaintCanvas Border Attribute 127 R+Height,C+1,R+Height,C+Width
             
     @ R+1,C+1 ?? Format("W"+Strval(Width-1)+",AL",Rank)   
     @ R+2,C+1 ?? Format("W"+Strval(Width-1)+",AL",Suit)   
     @ R+4,C+1 ?? Format("W"+Strval(Width-1)+",AR",Suit)   
     @ R+5,C+1 ?? Format("W"+Strval(Width-1)+",AR",Rank) 
     
EndProc     

;---CLASSES

Proc CardDeck.Create()
     Private Deck,i,j,Suits,Pictures
          
     Deck=Stack.Create()

     Array Suits[4]
     Suits[1]=Chr(5)
     Suits[2]=Chr(6)
     Suits[3]=Chr(3) 
     Suits[4]=Chr(4) 

     Array Pictures[4]
     Pictures[1]="J"
     Pictures[2]="Q"
     Pictures[3]="K"
     Pictures[4]="A"
       
     For i From 1 to ArraySize(Suits)
        
        For j From 1 to 10
            Stack.Push(Deck , Strval(j)+" "+Suits[i])
        EndFor
        
        For j From 1 to ArraySize(Pictures)
            Stack.Push(Deck , Pictures[j]+" "+Suits[i])
        EndFor
     
     Endfor
     
     Return Deck
EndProc

Proc CardDeck.DealCard(Object)
     Return Stack.PopRand(Object)
EndProc

Proc CardDeck.Destroy(Object)
     Stack.Destroy(Object) 
EndProc

Proc Stack.Create()
     Return OBP.ObjectCreate("Stack")
EndProc

Proc Stack.Push(Object,Value)
     OBP.Method(Object,"Stack$Push")
EndProc

Proc Stack$Push()
     Stack_Push(DynObject,Value)
EndPRoc

Proc Stack.Pop(Object)
     Return OBP.Method(Object,"Stack$Pop")
EndProc

Proc Stack$Pop()
     Return Stack_Pop(DynObject)
EndProc

Proc Stack.PopRand(Object)
     Return OBP.Method(Object,"Stack$PopRand")
EndProc

Proc Stack$PopRand()
     Return Stack_PopRand(DynObject)
EndProc

Proc Stack!Push(object,value)
     Execute "Stack_Push(Visage." + Strval(Object) + ",Value)"
EndProc     

Proc Stack!Pop(object)
     Execute "Stack_Pop(Visage." + Strval(Object) + ")"
     return Retval
EndProc     
      
Proc Stack_Push(DynObject,Value)
     private i
      
     i=0
     If DynArraySize(DynObject)>0 then 
        ForEach i in DynObject
          Quitloop
        EndForEach       
     Endif   
     
     DynObject[Numval(i)+1]=Value

EndProc

Proc Stack_Pop(DynObject)
     private i,Value

     If DynArraySize(DynObject)=0 then 
        Return False
     Endif   
     ForEach i in DynObject
        Quitloop
     EndForEach       
     
     Value=DynObject[i]
     Release vars DynObject[i]
     Return Value

EndProc

Proc Stack_PopRand(DynObject)
     private i,Value,Ct,CtMax

     If DynArraySize(DynObject)=0 then 
        Return False
     Endif   
     CtMax=Int(Rand()*DynArraySize(DynObject))-1
     
     Ct=0
     ForEach i in DynObject
       Ct=CT+1
       if Ct=CtMax then 
          Quitloop
       Endif   
     EndForEach  
     
     Value=DynObject[i]
     Release vars DynObject[i]
     Return Value

EndProc

Proc Stack.Destroy(Object)
     OBP.ObjectDestroy(Object)
EndProc     

Proc OBP.Create()
     DynArray Visage.ObjectType[]
EndProc

Proc OBP.Destroy()
     release vars Visage.ObjectType
EndProc

Proc OBP.ObjectCreate(ObjectType)
     private i,j,new
     
     i="0"
     if DynArraySize(Visage.ObjectType)>0 then
       Foreach i in Visage.ObjectType
         Quitloop
       EndForeach
     endif
     
     i=Numval(i)
     For j from 1 to 500
       new=mod(j+i,500)
       if not isassigned(Visage.ObjectType[new]) then
          Visage.ObjectType[new]=ObjectType
          Execute "DynArray Visage."+Strval(new)+"[]"  
          Quitloop
       endif   
     Endfor       
     
     return strval(new)

EndProc

Proc OBP.ObjectDestroy(Object)

     Execute "Release Vars Visage."+Strval(Object)
     
EndProc
 
Play "OBP" 

Sweat()
